<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * ajax.php
 * 
 */

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens,Sanitize};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;

    $aJsonRespond = [];
    $sModuleDir   = basename(dirname(__DIR__));
    // require config for Constants and DB access
    require(dirname(dirname(dirname(__DIR__))).'/config.php');
    // Check if user has enough rights to do this:
    // initialize json_respond array  (will be sent back)
    try{
        if (!class_exists('admin', false)){require(WB_PATH.'/framework/class.admin.php');}
        $admin = new admin('Modules', 'module_view', FALSE, FALSE);
    // first read and validate the $_POST arguments
        $aAllowedActions = ['updateItemPosition','toggle_template_active_status','toggle_item_active_status','delete_item','delete_template'];
        $sRequestAction  = $_POST['action'] ?:'';
        // test if action value is in allowed list of actions
        if ( !in_array($sRequestAction, $aAllowedActions)) {
            throw new Exception('no valid action was set');
        }
        if($sRequestAction == 'updateItemPosition'){
            $iRequestRecordId = $_POST['iItemRecordId'];
        }else{
            $iRequestRecordId = $_POST['iRecordId'];
        }
        $iRecordID = '';
        if (!($admin->is_authenticated() && $admin->get_permission($sModuleDir, 'module'))) {
            throw new Exception('You\'re not allowed to make changes to Module: ['.$sModuleDir.']');
        }
        switch ($sRequestAction):
            case 'updateItemPosition':
                $i = 1;
                foreach ($_POST['iItemRecordId'] as $iRecordID) {
                    // update database
                    $sql = 'UPDATE `'.TABLE_PREFIX.'mod_accordion_questions` SET '
                        .  '`pos`='.$i.' '
                        . 'WHERE `question_id`='.$iRecordID;
                    if (!(bool)$database->query($sql)) {
                        throw new Exception('DB access fail ['.$database->get_error().']');
                        $aJsonRespond['icon'] = 'stop.png';
                    }
                    $i++;
                } 
                $aJsonRespond['icon'] = 'success.png';
                $message = 'updateItemPosition '.$iRecordID;
            break;
            
            case 'toggle_item_active_status':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'UPDATE `'.TABLE_PREFIX.'mod_accordion_questions` SET '
                     . '`active`= (`active` IS NOT TRUE) '
                     . 'WHERE `question_id`='.$iIdKey;
//                throw new Exception('SQL:'.$sql);
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'toogleItemActivity '.$iIdKey;
            break;
            case 'toggle_template_active_status':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'UPDATE `'.TABLE_PREFIX.'mod_accordion_templates` SET '
                     . '`active`= (`active` IS NOT TRUE) '
                     . 'WHERE `template_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'toggleTemplate '.$iIdKey;
            break;
            case 'delete_item':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'DELETE FROM `'.TABLE_PREFIX.'mod_accordion_questions` '
                     . 'WHERE `question_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'deleteItem '.$iIdKey;
            break;
            case 'delete_template':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'DELETE FROM `'.TABLE_PREFIX.'mod_accordion_templates` '
                     . 'WHERE `template_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'deleteTemplate '.$iIdKey;
            break;
            
            default:
                throw new Exception('no valid "action" was set ');
                break;
        endswitch;
        
        $aJsonRespond['success'] = true;
//        $aJsonRespond['sIdKey']  = $admin->getIDKEY($iIdKey);
        //$aJsonRespond['sIdKey']  = $iIdKey;
        $aJsonRespond['message'] = $message;
    } catch (Exception $e) {
        $aJsonRespond['message'] = $e->getMessage();
        $aJsonRespond['success'] = false;
        //$aJsonRespond['sIdKey']  = $admin->getIDKEY($iIdKey);
        //$aJsonRespond['sIdKey']  = $iIdKey;
    }
    // echo the json_respond to the ajax function
    exit(json_encode($aJsonRespond));
