/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 * file..........ajaxActiveStatus.js
*/

(function($) {
        $.fn.ajaxActiveStatus = function(options) {

                var aOpts = $.extend({}, $.fn.ajaxActiveStatus.defaults, options);
                $(this).click(function() {
                        var oLink = $(this).find('a');
                        var oElement = $(this).find('img');
                        var iRecordId = oElement.attr("id").substring(7);
                        var oRecord = $("div#" + 'toggle_' + iRecordId);
                        switch(oElement.attr("src")){
                            case ACCORDION.ICONS +"/active_status_0.png": var action = "active_status_1"; break;
                            case ACCORDION.ICONS +"/active_status_1.png": var action = "active_status_0"; break;
                        }
                        
                        // pregenerate the data string
                        var sDataString = 'action='+aOpts.ACTION+'&iRecordId='+iRecordId;
                        //var sDataString = 'purpose='+aOpts.ACTION+'&action='+aOpts.ACTION+'&iRecordId='+iRecordId;              
                        $.ajax({
                                url: ACCORDION.AJAX_PLUGINS +'/ajax.php',
                                type: "POST",
                                dataType: 'json',
                                data: sDataString,
                                success: function(json_respond) {
                                    if(json_respond.success === true) {
                                        oRecord.attr("id", json_respond.sIdKey);
                                        oElement.attr("id", "toggle_"+ json_respond.sIdKey);
                                        oElement.attr("src", ACCORDION.ICONS + "/"+ action +".png");
                                        oElement.animate({opacity: 1});
                                        var INFO_BOX = jQuery("#" + RESULTS_CONTAINER);
                                        INFO_BOX.html('<span id="alertFadeOut"> <img id="reload_img" src="'+ ACCORDION.ICONS +'/' + json_respond.icon +'" alt="" /> ' + LANG.CHANGE_ITEM_ACTIVITY + '</span>').fadeIn("slow");
                                        jQuery("#alertFadeOut").fadeOut(1000);
                                        window.location.reload();
                                    } else {
                                            oRecord.attr("id", json_respond.sIdKey);
                                            oElement.attr("id", "active_"+ json_respond.sIdKey);
                                            alert(json_respond.message);
                                    }
                                }
                        });
                });
        };
})(jQuery);
