<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * Modify.inc.php
/* -------------------------------------------------------- */
//            echo "<pre>POST in Modifyquest.inc.php:<br>";
//            print_r($_POST);
//            echo "</pre>";
////
//            echo "<pre>GET in Modifyquest.inc.php:<br>";
//            print_r($_GET);
//            echo "</pre>";

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

$iActualSectionID = $oRequest->getParam('section_id');
if ($iActualSectionID == $section_id){
//load some initial datas
if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
// secure check - correct FTAN?

$oTrans->enableAddon('modules\\\\'.$sAddonName);
    
    // back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    
    // secure check - correct FTAN?
if (!\bin\SecureTokens::checkFTAN ()) {
    $aMessage = \sprintf("%s\n","ModifyQuestion - Missing FTAN ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    $admin->print_error($aMessage, $sAddonBackUrl );
}
// secure check - correct IDKey for image_id?
$iQuestID = \bin\SecureTokens::checkIDKEY($aRequestVars['question_idkey']);
if ((\is_numeric($iQuestID) && ($iQuestID == 0)) || (!$iQuestID)){
    $aMessage = \sprintf("%s\n","ModifyQuestion - Missing IDKey ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    $admin->print_error($aMessage, $sAddonBackUrl );
}


$content = '';
$name = 'answer';
if (!isset($wysiwyg_editor_loaded)) {
    $wysiwyg_editor_loaded=true;
    if (!\defined('WYSIWYG_EDITOR') OR WYSIWYG_EDITOR=="none" || !\file_exists(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php')) {
        function show_wysiwyg_editor($name,$id,$content,$width,$height) {
            echo '<textarea name="'.$name.'" id="'.$id.'" style="width: '.$width.'; height: '.$height.';">'.$content.'</textarea>';
        }
    } else {
        $sTableName = 'mod_wysiwyg';
        $id_list = [];
        require(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
    }
}
ob_start();     // start output buffer
show_wysiwyg_editor('answer','content',$content,'100%','358px',"utf8mb4");
$show_editor=ob_get_contents();
ob_end_clean();

$iActualTime                                    = time();
$aFtan                                          = SecureTokens::getFTAN();
// complete array with replacements
$aTplDefaults = array(
        'WB_URL'               => WB_URL,
        'WB_PATH'              => WB_PATH,
        'MODULE_THEME_URL'     => $sAddonThemeUrl,
        'MODULE_THEME_PATH'    => $sAddonThemePath,
        'ICON_URL'             => $sAddonThemeUrl.'/images',
        'ADDON_NAME'           => strtolower($sAddonName),
        'ADDONNAME'            => strtoupper($sAddonName),
        'ADDONURL'             => $sAddonUrl,
        'LANGUAGE'             => LANGUAGE,
        'PAGE_ID'              => $page_id,
        'SECTION_ID'           => $section_id,
        'FTAN_NAME'            => $aFtan['name'],
        'FTAN_VALUE'           => $aFtan['value'],
        'WYSIWYG_EDITOR'       => WYSIWYG_EDITOR,
        'LANGUAGE'             => LANGUAGE,
        'ICON_URL'             => $sAddonThemeUrl.'/images',
        'THEME_URL'            => $sAddonThemeUrl,
        'MODIFY_URL'           => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id,
        'SAVE_URL'             => ADMIN_URL.'/pages/save.php',
        'CANCEL_URL'           => $sAddonBackUrl,
        'NEW_ADD_ID'           => SecureTokens::getIDKEY('999999'),
        'ACTUALTIME'           => $iActualTime,
        'ACTUALUSERID'         => $admin->getUserId(),
        'ACTUALTIME'           => $iActualTime,
        'MYEDITOR'             => $show_editor,
    );

    $aTwigdata = $aTplDefaults;
     
$oBEFunctions                                   = new Accordion();
//settings
$aTwigdata['setting']                           = $oBEFunctions->getAccordionSettings($section_id);
$aTwigdata['lang']                              = $oTrans->getLangArray();

if (is_readable($sAddonThemePath.'/AddNewQuestion.twig'))
    {
        // create twig template object
        $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
        $oTwig  = new \Twig\Environment($loader, [
            'autoescape'       => false,
            'cache'            => false,
            'strict_variables' => false,
            'debug'            => false,
            'auto_reload'      => true,
        ]);
        $oTwig->addFilter(new TwigFilter('strftime', 'strftime_filter'));
        $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
        echo $oTwig->render('AddNewQuestion.twig', $aTwigdata);
    }
}else{
    echo $oTrans->ACCTEXT_INACTIVE_SECTION."<br>";
    
}
// end of file

