<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * Modify.inc.php
/* -------------------------------------------------------- */
//            echo "<pre>POST in Modify.inc.php:<br>";
//            print_r($_POST);
//            echo "</pre>";
//
//            echo "<pre>GET in Modify.inc.php:<br>";
//            print_r($_GET);
//            echo "</pre>";

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */


//load some initial datas
if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
$oTrans->enableAddon('modules\\\\'.$sAddonName);

// back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;

//Delete empty records
$sSql = 'DELETE FROM `'.TABLE_PREFIX.'mod_accordion_questions` WHERE `section_id` = '.(int)$section_id.' and `question` = \'\' ';
$database->query($sSql);

//Delete empty records
$sSql = 'DELETE FROM `'.TABLE_PREFIX.'mod_accordion_questions` WHERE `section_id` = \'0\' ' ;
$database->query($sSql);

$iActualTime                                    = time();
$aFtan                                          = SecureTokens::getFTAN();

// complete array with replacements
$aTplDefaults = array(
    'WB_URL'                                    => WB_URL,
    'MODULE_THEME_URL'                          => $sAddonThemeUrl,
    'MODULE_THEME_PATH'                         => $sAddonThemePath,
    'ICON_URL'                                  => $sAddonThemeUrl . '/images',
    'ADDON_NAME'                                => strtolower($sAddonName),
    'ADDONNAME'                                 => strtoupper($sAddonName),
    'ADDONURL'                                  => $sAddonUrl,
    'PAGE_ID'                                   => $page_id,
    'SECTION_ID'                                => $section_id,
    'FTAN_NAME'                                 => $aFtan['name'],
    'FTAN_VALUE'                                => $aFtan['value'],
    'LANGUAGE'                                  => LANGUAGE,
    'WYSIWYG_EDITOR'                            => WYSIWYG_EDITOR,
    'SETTINGSID'                                => $admin->getIDKEY('Settings'),
    'MODIFY_URL'                                => ADMIN_URL . '/pages/modify.php?page_id=' . (int) $page_id.$sec_anchor,
    'EDIT_URL'                                  => ADMIN_URL . '/pages/modify.php?page_id=' . (int) $page_id,
    'SAVE_URL'                                  => ADMIN_URL . '/pages/save.php',
    'ADDQUEST'                                  => SecureTokens::getIDKEY('AddQuest'),
    'NEW_ADD_ID'                                => SecureTokens::getIDKEY('999999'),
    'EDITTEMPLATE'                              => SecureTokens::getIDKEY('EditTemplate'),
    'DATAICON_URL'                              => $sAddonThemeUrl . '/images/msdropdown/icons/',    
    'ADMIN_ID'                                  => $admin->getUserId(),
);
$aTwigdata = $aTplDefaults;

if(\is_readable($sAddonPath.'/backend.css')){ $aFilenames[] = 'backend.css';$sCssFilePath = $sAddonPath.'/';}   
if(\is_readable($sAddonPath.'/frontend.css')){ $aFilenames[] = 'frontend.css';$sCssFilePath = $sAddonPath.'/';}
if(\is_readable($sAddonPath.'/backendUser.css')){ $aFilenames[] = 'backendUser.css';$sCssFilePath = $sAddonPath.'/';}
if(\is_readable($sAddonPath.'/frontendUser.css')){ $aFilenames[] = 'frontendUser.css';$sCssFilePath = $sAddonPath.'/';}
if(\is_readable($sAddonThemePath.'/css/backend_default.css')){ $aFilenames[] = 'backend_default.css';$sCssFilePath = $sAddonThemePath.'/css/';}
if(\is_readable($sAddonTemplatePath.'css/frontend_default.css')){ $aFilenames[] = 'frontend_default.css';$sCssFilePath = $sAddonTemplatePath.'css/';}

        foreach ($aFilenames AS $key => $sCssEditFile){
            $sFilename = $sCssEditFile;
            $sFileIdkey[$sCssEditFile]= SecureTokens::getIDKEY($sCssEditFile);
            $aTwigdata['AvaiableCss'] = array(
                'filekey'                         => $sFileIdkey,
            );
        }
$sTableName = TABLE_PREFIX.'mod_accordion_templates';        
if ($database->table_exists($sTableName)){        
// template install, if needed
    $sql = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_accordion_templates` '
         . 'WHERE `section_id` = 0 '
         . 'OR `section_id` = '.(int)$section_id;
    if (!$database->get_one($sql)) {
        // import template(s) tables from sql dump file
        if (is_readable(dirname(__DIR__).'/install-data.sql.php')) {
            $database->SqlImport((dirname(__DIR__)).'/install-data.sql.php', TABLE_PREFIX, __FILE__ );
        }
    } 
// update templates for this section
    $sql = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_accordion_templates` '
         . 'WHERE `section_id` = 0 ';
    if ($database->get_one($sql)) {
        // if matching record already exists run UPDATE
        $sqlUpdate = 'UPDATE `'.TABLE_PREFIX.'mod_accordion_templates` SET '
                  .  '`section_id` = '.$section_id.',  '
                  .  '`page_id` = '.$page_id.' ' 
                  .  'WHERE `section_id`= 0 ';
        if (!$database->query($sqlUpdate)){
            throw new \Exception ($database->get_error());
        }
    }
}
        
$oBEFunctions                                   = new Accordion();
//settings
$aTwigdata['setting']                           = $oBEFunctions->getAccordionSettings($section_id);
// item sort mode
$iItemOrder                                     = $oBEFunctions->getItemSortMode($section_id);
// Get comple list of entries
$aTwigdata['ITEMLIST']                          = $oBEFunctions->getAllItemsArray($section_id,$iItemOrder);
// Get total number of entries
$aTwigdata['CountEntries']                      = $oBEFunctions->CountEntrys($section_id);
// Get total number of inactive entries
$aTwigdata['CountInactiveEntrys']               = $oBEFunctions->CountInactiveEntrys($section_id);
// read all Templates
$aTwigdata['TemplateList']                      = $oBEFunctions->getAllTemplatesArray($section_id);
// all language variables from WB
$aTwigdata['lang']                              = $oTrans->getLangArray();
//
//            echo "<pre>Modify.inc.php";
//            print_r($aTwigdata);
//            echo "</pre>";

    if (is_readable($sAddonThemePath.'/Modify.twig'))
        {
            // create twig template object
            $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
            $oTwig  = new \Twig\Environment($loader, [
            'autoescape'       => false,
            'cache'            => false,
            'strict_variables' => false,
            'debug'            => false,
            'auto_reload'      => true,
        ]);
        $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
        echo $oTwig->render('Modify.twig', $aTwigdata);
    }
   
// end of file
