<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * Modifycss.inc.php
/* -------------------------------------------------------- */

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
$iActualSectionID = $oRequest->getParam('section_id');
if ($iActualSectionID == $section_id){

//
//        echo "<pre>ModifyCss.inc.php<br>";
//        print_r($_POST);
//        echo "</pre>";

//load some initial datas
    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
     
    $oTrans->enableAddon('modules\\\\'.$sAddonName);
    // back to the module overview
    $sec_anchor = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    
    // secure check - correct FTAN?
    if (!\bin\SecureTokens::checkFTAN ()) {
        $aMessage = \sprintf("%s\n","ModifyCSS - Missing FTAN ".$MESSAGE['GENERIC_SECURITY_ACCESS']);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    
    $sCssEditFile = '';
    $sCssEditFile = $admin->checkIDKEY('edit_file', false,'POST');
    if($sCssEditFile === false ) {
        $aMessage = \sprintf("%s\n","ModifyCSS - Missing IDKey ".$MESSAGE['GENERIC_SECURITY_ACCESS']);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    if (!function_exists('edit_module_css')) {include(WB_PATH .'/framework/module.functions.php');}    
    if (!function_exists('loader_help')){require(WB_PATH.'/include/editarea/wb_wrapper_edit_area.php');}
    
    if (($sCssEditFile=='frontend.css')|| ($sCssEditFile=='backend.css')|| ($sCssEditFile=='backendUser.css')|| ($sCssEditFile=='frontendUser.css')){
        if(\is_readable($sAddonPath.'/'.$sCssEditFile)){
            $sCssEditFilePath = $sAddonPath.'/'.$sCssEditFile; 
        }
    }elseif($sCssEditFile=='frontend_default.css'){
        if(\is_readable($sAddonTemplatePath.'css/'.$sCssEditFile)){
            $sCssEditFilePath = $sAddonTemplatePath.'css/'.$sCssEditFile; 
        }
    }elseif($sCssEditFile=='backend_default.css'){
        if(\is_readable($sAddonThemePath.'/css/'.$sCssEditFile)){
            $sCssEditFilePath = $sAddonThemePath.'/css/'.$sCssEditFile; 
        }
    }
    
   
//    $sModuleCssEdit = \@file_get_contents($sCssEditFilePath,null,null,0,\filesize ($sCssEditFilePath));
    $sModuleCssEdit = \file_get_contents($sCssEditFilePath);
    $iRedirectTimer = ((\defined( 'REDIRECT_TIMER')) && ( REDIRECT_TIMER <= 10000)) ? REDIRECT_TIMER : 0;
    $aFtan = SecureTokens::getFTAN();
    // complete array with replacements
    $aTplDefaults = array(
            'WB_URL' => WB_URL,
            'MODULE_THEME_URL'                  => $sAddonThemeUrl,
            'MODULE_THEME_PATH'                 => $sAddonThemePath,
            'ICON_URL'                          => $sAddonThemeUrl.'/images',
            'ADDON_NAME'                        => strtolower($sAddonName),
            'ADDONNAME'                         => strtoupper($sAddonName),
            'ADDONURL'                          => $sAddonUrl,
            'PAGE_ID'                           => $page_id,
            'SECTION_ID'                        => $section_id,
            'FTAN_NAME'                         => $aFtan['name'],
            'FTAN_VALUE'                        => $aFtan['value'],
            'LANGUAGE'                          => LANGUAGE,
            'ICON_URL'                          => $sAddonThemeUrl.'/images',
            'THEME_URL'                         => $sAddonThemeUrl,
            'WYSIWYG_EDITOR'                    => WYSIWYG_EDITOR,
            'MODIFY_URL'                        => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id,
            'SAVE_URL'                          => ADMIN_URL.'/pages/save.php',
            'CANCEL_URL'                        => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id,
            'EDITTCSSFILE'                      => $admin->getIDKEY('EditCssFile'),
            'FILECONTENT'                       => $sModuleCssEdit,
            'FILENAME'                          => $sCssEditFile,
            'REAL_PATH'                         => $sCssEditFilePath,
            'FILE_IDKEY'                        => $admin->getIDKEY($sCssEditFile),
            'SUCCESSFULL_SAVED'                 => $oTrans->ACCTEXT_CSS_SUCCESSFULL_SAVED ,
            'TEXT_CLOSE'                        => $oTrans->ACCTEXT_TEXT_CLOSE ,
            'REDIRECT_TIMER'                    => $iRedirectTimer,
            'REDIRECT_URL'                      => $sAddonBackUrl,
        );
    
    $aTwigdata = $aTplDefaults;
    $aTwigdata['lang']                              = $oTrans->getLangArray();

    if (is_readable($sAddonThemePath.'/ModifyCssFile.twig'))
        {
            // create twig template object
            $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
            $oTwig  = new \Twig\Environment($loader, [
                'autoescape'       => false,
                'cache'            => false,
                'strict_variables' => false,
                'debug'            => false,
                'auto_reload'      => true,
            ]);
        $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
        echo $oTwig->render('ModifyCssFile.twig', $aTwigdata);
    }    
}else{
    echo $oTrans->ACCTEXT_INACTIVE_SECTION."<br>";
    
}     
// end of file