<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * Savecssfile.inc.php
/* -------------------------------------------------------- */

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
//    echo "<pre>";
//    print_r($_POST);
//    echo "</pre>";

//load some initial datas
    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    
    $oTrans->enableAddon('modules\\\\'.$sAddonName);
    
    // back to the module overview
    $sec_anchor = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    

   
    // secure check - correct FTAN?
    if (!\bin\SecureTokens::checkFTAN ()) {
        $aMessage = \sprintf("%s\n","ModifyTemplate - Missing FTAN ".$MESSAGE['GENERIC_SECURITY_ACCESS']);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    // secure check - correct adresspage?
    $sFilecheck = $admin->checkIDKEY('EditCssFile', false,'POST');
    if($sFilecheck === false ) {
        $aMessage = \sprintf("%s\n","ModifyCssFile - Missing IDKey ".$MESSAGE['GENERIC_SECURITY_ACCESS']);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    // secure check - correct File?
    $sCssFileToEdit = $admin->checkIDKEY('file_idkey', false,'POST');
    if($sCssFileToEdit === false ) {
        $aMessage = \sprintf("%s\n","ModifyCssFile - Not possible to edit this file - unknown filename - ".$MESSAGE['GENERIC_SECURITY_ACCESS']);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    
//    $aFtan = SecureTokens::getFTAN();
//    $iRedirectTimer = ((\defined( 'REDIRECT_TIMER')) && ( REDIRECT_TIMER <= 10000)) ? REDIRECT_TIMER : 0;
    
    // found the correct filepath to save the content
    if(($sCssFileToEdit == 'backend.css') && (\is_readable($sAddonPath.'/backend.css'))){
        $sCssFileSavePath = $sAddonPath.'/backend.css';
    }
    if(($sCssFileToEdit == 'frontend.css') && (\is_readable($sAddonPath.'/frontend.css'))){
        $sCssFileSavePath = $sAddonPath.'/frontend.css';
    }
    if(($sCssFileToEdit == 'backendUser.css') && (\is_readable($sAddonPath.'/backendUser.css'))){
        $sCssFileSavePath = $sAddonPath.'/backendUser.css';
    }
    if(($sCssFileToEdit == 'frontendUser.css') && (\is_readable($sAddonPath.'/frontendUser.css'))){
        $sCssFileSavePath = $sAddonPath.'/frontendUser.css';
    }
    if(($sCssFileToEdit == 'backend_default.css') && (\is_readable($sAddonThemePath.'/css/backend_default.css'))){
        $sCssFileSavePath = $sAddonThemePath.'/css/backend_default.css';
    }
    if(($sCssFileToEdit == 'frontend_default.css') && (\is_readable($sAddonTemplatePath.'css/frontend_default.css'))){
        $sCssFileSavePath = $sAddonTemplatePath.'css/frontend_default.css';
    }
    
    // css-file-content        
    if (isset($aRequestVars['file_code']) && (!empty($aRequestVars['file_code'])) ) {
        $sCssFileContent = $aRequestVars['file_code'];
    } 
//    echo "Datei ist: ".$sCssFileToEdit." - Pfad ist: ".$sCssFileSavePath."<br>";
    
    if (!empty($sCssFileContent)&& \file_put_contents($sCssFileSavePath,$sCssFileContent)) {
        $msg[] = sprintf($oTrans->ACCTEXT_CSS_SUCCESSFULL_SAVED,($sCssFileToEdit));
        $admin->print_success(\implode('<br>',$msg), $sAddonBackUrl);
        $admin->print_footer();
        exit;
    } else {
        $msg[] = sprintf($oTrans->ACCTEXT_CSS_NOT_SAVED,($sCssFileToEdit));
        $admin->print_error(\implode('<br>',$msg), $sAddonBackUrl);
        $admin->print_footer();
        exit;
    }
    

// end of file

