<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * Savepicture.inc.php
 */

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens,Sanitize};
use bin\helpers\{PreCheck};


/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if(defined('WB_PATH') == false) { die('Illegale file access /'.basename(__DIR__).'/'.basename(__FILE__).''); }
/* -------------------------------------------------------- */

//    
//    echo "<pre>";
//    print_r($_POST);
//    echo "</pre>";

//load some initial datas
   if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    $oTrans->enableAddon('modules\\\\'.$sAddonName);
    $sec_anchor = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    

try {
    if(isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'Savequest')) { 
        $iActualTime = time()+ TIMEZONE;
        // image_idkey
        if(isset($aRequestVars['question_idkey'])) {
                $QuestID = \bin\SecureTokens::checkIDKEY($aRequestVars['question_idkey']);    
        }else{
            throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
        }    
        // question / default=''
        if(isset($aRequestVars['question']) && ($aRequestVars['question'] != '')) {
            $sQuestion = Sanitize::StripFromText($admin->get_post('question'),Sanitize::REMOVE_DEFAULT);
        }
        
        // status_on_pageload / default=''
        if(isset($aRequestVars['status_on_pageload']) && ($aRequestVars['status_on_pageload'] == 'open')) {
            $sStateOfPageload = 'open';
        }else{
            $sStateOfPageload = '0';
        }
        
        // answer
        $sAnswer = '';
        if(isset($aRequestVars['answer'])) {
            $sAnswer = $aRequestVars['answer'];
            $sAnswer = $admin->ReplaceAbsoluteMediaUrl($sAnswer);
        }
        
        // position        
        if (isset($aRequestVars['pos']) && is_numeric($aRequestVars['pos']) ) {
            $position = intval($aRequestVars['pos']);
        } else {
            $position= 0;
        }

        // active        
        if (isset($aRequestVars['active']) && is_numeric($aRequestVars['active']) ) {
            $active = intval($aRequestVars['active']);
        } else {
            $active = 0;
        }
        
        $iActualTime = time()+ TIMEZONE;
        $iModifiedWhen = $iActualTime;
        $iModifiedBy = $admin->getUserId();
        
        
        $sPictureLink ='';
        
        $sqlSet =  '`'.TABLE_PREFIX.'mod_accordion_questions` SET '
                .  '`section_id`                = '.(int)$section_id.', '
                .  '`page_id`                   = '.(int)$page_id.', '
                .  '`pos`                       = '.(int)$position.', '
                .  '`active`                    = '.(int)$active.', ' 
                .  '`question`                  = \''.$database->escapeString($sQuestion).'\', '               
                .  '`answer`                    = \''.$database->escapeString($sAnswer).'\', '
                .  '`status_on_pageload`        = \''.$database->escapeString($sStateOfPageload).'\', '
                .  '`modified_when`             = '.(int)$iModifiedWhen.', ' 
                .  '`modified_by`               = '.(int)$iModifiedBy.' ';


        // search for instance of this module in section
        $sql = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_accordion_questions` '
             . 'WHERE `section_id` = '.$section_id.' '
             . 'AND `question_id` = '.$QuestID;
        if ($database->get_one($sql)) {
            // if matching record already exists run UPDATE
            $sql = 'UPDATE '.$sqlSet.' '
                  .'WHERE `section_id` = '.$section_id.' '
                  .'AND `question_id` = '.$QuestID;
            $action = 'upgrade';
//            echo 'UPDATE: <br>'.$sql;
        } else {
            // if no matching record exists INSERT new record// Insert row
            $sql = 'INSERT INTO '.$sqlSet;
            $action = 'insert';
//            echo 'INSERT: <br>'.$sql;
        }

        if (!$database->query($sql)){
            throw new \Exception ($database->get_error());
        }
        if($action == 'insert'){
            $oSortQuests   = new order(TABLE_PREFIX.'mod_accordion_questions', 'pos', 'question_id', 'section_id');
        }
        if ($position == 0){
            $oSortQuests   = new order(TABLE_PREFIX.'mod_accordion_questions', 'pos', 'question_id', 'section_id');
            $oSortQuests->clean( $section_id );
        }
    }
     
} catch (\Exception $ex) {

    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}



