<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * SaveSettings.inc.php
 */
//
//        echo "<pre>";
//        print_r($_POST);
//        echo "</pre>";
//      

        
use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};


/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if(defined('WB_PATH') == false) { die('Illegale file access /'.basename(__DIR__).'/'.basename(__FILE__).''); }
/* -------------------------------------------------------- */


    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    $sec_anchor = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    //  FTAN-CHECK
    $sSettingsID = $admin->checkIDKEY('SettingsID', false, 'POST');
        // Get id
    if(!$sSettingsID) {
        $admin->print_error('SaveSettings.php '.$MESSAGE['GENERIC_SECURITY_ACCESS'], $sAddonBackUrl);
                exit();
    }
    $newSettings = array();
    $aErrorMsg = array();
    //Daten aus $aRequestVars auswerten und validieren
    $newSettings['section_id'] = $section_id;
    $newSettings['page_id'] = $page_id;
    
try {    
    if(isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'Savesetting')) {  
        // ordering
        if (isset($aRequestVars['ordering']) && is_numeric($aRequestVars['ordering']) ) {
            $newSettings['ordering'] =  intval($aRequestVars['ordering']);
        } else {
            $newSettings['ordering'] = 1;
        }
        
        //accordion_method - default: accordion
        if (isset($aRequestVars['accordion_method']) && is_string($aRequestVars['accordion_method']) && $aRequestVars['accordion_method'] == 'toggle') {
            $newSettings['accordion_method'] = 'toggle';
        }else{
            $newSettings['accordion_method'] = 'accordion';
        }
        
        //icon_placement - default: symbol-left
        if (isset($aRequestVars['icon_placement']) && is_string($aRequestVars['icon_placement']) && $aRequestVars['icon_placement'] == 'symbol-right') {
            $newSettings['icon_placement'] = 'symbol-right';
        }else{
            $newSettings['icon_placement'] = 'symbol-left';
        }
        
        // output_template - default = view_original.twig
        if (isset($aRequestVars['output_template']) && is_numeric($aRequestVars['output_template']) ) {
            $newSettings['output_template'] =  intval($aRequestVars['output_template']);
        } else {
            $newSettings['output_template'] = 1;
        }
        
        // use_templates - default = view_original.twig
        if (isset($aRequestVars['use_templates']) && is_numeric($aRequestVars['use_templates']) ) {
            $newSettings['use_templates'] =  intval($aRequestVars['use_templates']);
        } else {
            $newSettings['use_templates'] = 0;
        }
                
        // use_wysiwyg - default = view_original.twig
        if (isset($aRequestVars['use_wysiwyg']) && is_numeric($aRequestVars['use_wysiwyg']) ) {
            $newSettings['use_wysiwyg'] =  intval($aRequestVars['use_wysiwyg']);
        } else {
            $newSettings['use_wysiwyg'] = 1;
        }
        
        //icon - default: default
        if (isset($aRequestVars['icon']) && is_string($aRequestVars['icon']) && $aRequestVars['icon'] == 'chevrons') {
            $newSettings['icon'] = 'chevrons';
        } elseif (isset($aRequestVars['icon']) && is_string($aRequestVars['icon']) && $aRequestVars['icon'] == 'signs') {
            $newSettings['icon'] = 'signs';
        } elseif (isset($aRequestVars['icon']) && is_string($aRequestVars['icon']) && $aRequestVars['icon'] == 'carets') {
            $newSettings['icon'] = 'carets';
        } elseif (isset($aRequestVars['icon']) && is_string($aRequestVars['icon']) && $aRequestVars['icon'] == 'circle-arrows') {
            $newSettings['icon'] = 'circle-arrows';
        }else{
            $newSettings['icon'] = 'default';
        }

        $iAdminRights = (($admin->ami_group_member('1')||$admin->get_permission('settings_view')) ? 29 : 26);
        $newSettings['header']                  = ($admin->StripCodeFromText($admin->get_post('header'),$iAdminRights) ?? '');
        $newSettings['footer']                  = ($admin->StripCodeFromText($admin->get_post('footer'),$iAdminRights) ?? '');
        
        //SQL wich is used for all updates
        $rawUpdtSQL = "UPDATE `".TABLE_PREFIX."mod_accordion_settings` SET `s_value` = '%s' WHERE "
                     ."`section_id` = '".$section_id."' AND `s_name` = '%s';";
        // execute SQL
        $sUpdateSql =array();
        foreach ($newSettings as $s_name=>$s_value){
            if (!is_array($s_value)) {
                $sSql = sprintf($rawUpdtSQL, $database->escapeString($s_value), $s_name);
            } else {
                $sSql = sprintf($rawUpdtSQL, serialize($s_value), $s_name);
            }
            $sUpdateSql[] = $sSql;
//            echo $sSql."<br>";
            if (!$database->query($sSql)){
                throw new \Exception ($database->get_error());
            }
        }

    }
} catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error($sErrMsg, $sAddonBackUrl);
    exit;
}
//end of file

