<?php
/*
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * Upgrade.inc.php
 * 
 */
// prevent this file from being accessed directly
/* -------------------------------------------------------- */



use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck};
// prevent this file from being accessed directly
/* -------------------------------------------------------- */
// Must include code to prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; flush(); exit; }
/* -------------------------------------------------------- */
/*
 * BEGIN: Create new settings table
 */

    $sAddonPath = str_replace('\\','/',dirname(__DIR__)).'/';
    $sAddonName = \basename($sAddonPath);
    $aMsg = [];
    $sMsg = '';
    $iErr = false;
    $bLoaded = null;

try {
    $oReg = WbAdaptor::getInstance();
/**
 * change update.fixed to update
 * if any template or javascript fixed in templates/default/ folder
 */
     $sTemplateFile = 'none';
     $sUpgradeFile = $sAddonPath.'update';
     $isUpgradeFile = $sUpgradeFile.'.fixed';
     if (\is_readable($sUpgradeFile)){
        if (!\rename($sUpgradeFile, $sUpgradeFile.'.fixed')){
            echo $sMsg = \sprintf('renaming of %s %s <br />',\basename($sUpgradeFile.'.fixed'), 'FAILED');
        } elseif(!$isUpgradeFile) {
            $sTemplateFile = ($oReg->Template ?? 'none');
        }
    }

    if (\is_readable($sAddonPath.'init.php')) {require ($sAddonPath.'init.php');}
    // check if upgrade startet by upgrade-script to echo a message
    $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
    Translate::getInstance()->enableAddon(ADMIN_DIRECTORY.'\\addons');
    if (\is_writable(WB_PATH.'/temp/cache')) {
        Translate::getInstance()->clearCache();
    }
    $aRequired['PHP'] = [
          'Addon'  => 'PHP',
          'version' => \PHP_VERSION,
          'required' => '7.4',
          'operator' => '>=',
          ];
    $sTmp   = PreCheck::getMissingRequirements($aRequired);
    if (!empty($sTmp)){$aMsg[] = $sTmp."\n";}
    if (!empty($aMsg)){
//        throw new \InvalidArgumentException(($aMsg));
    }
    unset($aRequired);
    $aRequired['PHP'] = [
          'Addon'  => 'WebsiteBaker',
          'version' => $sWbVersion,
          'required' => '2.13.0',
          'operator' => '>=',
          ];
    $sTmp   = PreCheck::getMissingRequirements($aRequired);
    if (!empty($sTmp)){$aMsg[] = $sTmp."\n";}
    if (!empty($aMsg)){
        $sMsg = ((\is_array($aMsg)) ? (\implode("\n",$aMsg)) : "unknown Error");
        throw new \InvalidArgumentException($sMsg);
    }
    unset($aRequired);


    $OK   = '<span class="ok">OK</span>';
    $FAIL = '<span class="error">FAILED</span>';
    $iErr = false;
    $sNameValPairs    = '';
    $bOldStructure    = false;
//    $sAddonName       = \basename(__DIR__);
    $sTablePrefix      = $database->getTablePrefix();
    $sTableName       = $sTablePrefix.'mod_accordion_settings';
    $i = (!isset($i) ? 1 : $i);
    $sInstallStruct   = $sAddonPath.'/install-struct.sql.php';
    $sInstallUpdate   = $sAddonPath.'/install-upgrade.sql.php';

//    $dbName           = DB_NAME;
    $iErr = false;
    $aSettings        = [];
    $aNewSettings     = [];
    $aOldSettings     = [];
    $aDefaultSettings = [];

    if (!\is_readable($sInstallUpdate)) {
        $aMsg[] = sprintf("<strong>missing or not readable file [install-upgrade.sql]</strong> %s\n",$FAIL);
        $iErr = true;
    } else {
            
            $selectSettings = (function() use ($database, $sTableName) {
            $aSettings =  [];
            $sql = 'SELECT * FROM `'.$sTableName.'`';
            if ($oRes = $database->query($sql)){
                $aSettings = $oRes->fetchAll(MYSQLI_ASSOC);
            }
            return ((\count($aSettings) > 0) ? $aSettings : $aDefaults);
        });
        
        // prepare an array to create the sql statement
        $prepareSettings = (function($aOldSettings) use ($aSettings)
        {
            $i=0;
            $y=1;
            $iSectionId = 0;
//            $aInvisibile = \explode(',',$aDefaults['invisible']);
            $iSectionId = $aOldSettings[$i]['section_id'];
            $aTmpSettings = [];
            $aTmpSettings[$i]['section_id'] = $iSectionId;
            foreach ($aOldSettings as $aSettings) {
                $sIndexName =  $aSettings['s_name'];
                $sValue     =  $aSettings['s_value'];
                $bChangeSection = ($iSectionId !== $aSettings['section_id']);
                if ($bChangeSection){
                    $i++;
                    $y = 1;
                    $iSectionId =  $aSettings['section_id'];
                    $aTmpSettings[$i]['section_id'] = $iSectionId;
                    $aTmpSettings[$i][$sIndexName] = $sValue;
                } else {
                    $aTmpSettings[$i][$sIndexName] = $sValue;
                }
                $y++;
            }
            return ((\count($aTmpSettings) > 0) ? $aTmpSettings : false);
        });

        // try to create table if not exists
        $database->SqlImport($sInstallStruct, TABLE_PREFIX, true );
        // read settings first
        $sql = 'SELECT * FROM `'.$sTableName.'`';
        // check if table already upgraded
        if ( $bOldStructure = $database->field_exists($sTableName, 'page_id') )
        {
            if (!($aOldSettings = $selectSettings()))
            {
                $aMsg[] = sprintf("[%03d]<strong>Accordion backup old settings</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            }
        } elseif ($database->field_exists($sTableName, 's_name'))
        {
            // overwrite standardsettings ($aOldSettings)
            if (!($aOldSettings = $selectSettings()))
            {
                $aMsg[] = sprintf("[%03d] <strong>Accordion has no old settings</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            } else {
                // prepare an array to create the sql statement
                $aOldSettings = $prepareSettings($aOldSettings);
            }
        } // end handling new structure
               
        if ($database->index_exists($sTableName,'indent_accord')){$database->index_remove($sTableName,'indent_accord');}
       // delete none allowed entries in settings.s_name
        $aSettingsDenied = ['s_name','s_value']; //'section_id',
        // drop old table and create new one  ident_accord
        if ((\count($aOldSettings)
            && !$iErr && \count($aDefaults))
            && $database->SqlImport($sInstallUpdate, $sTablePrefix, false) //$sInstallUpdate
            ) {
           // restore old settings if there any
            if ($aOldSettings && !$iErr)
            {
                $iSectionId = 0;
                foreach ($aOldSettings as $aItems) {
                    // add new default settings
                    $aSettings  = \array_merge( $aDefaults, $aItems );//replace_recursive

                    $iSectionId = $aSettings['section_id'];
                    // update sections modulename if changed with same table structure
                    $sqlSection = 'UPDATE `'.$sTablePrefix.'sections` SET '
                                . '`module` = \''.$sAddonName.'\' '
                                . 'WHERE `section_id` = '.$iSectionId.';';
                    if (!$database->query($sqlSection)){
                          $aMsg[] = sprintf("[%03d] <strong>Database error table sections  %s</strong>",__LINE__,$database->get_error() );
                          $aMsg[] = sprintf("[%03d] <strong>Accordion couldn\'t change sections entry ID %s</strong> %s",__LINE__,$iSectionId, $FAIL );

                        }

                    $sNameValPairs = '';
// insert settings per section
                    foreach ($aSettings as $index => $val) {
                        if (\in_array($index, $aSettingsDenied) ) { continue; }

                        $sNameValPairs .= ','."\n".' ('.$iSectionId.', \''.$index.'\', \''.$database->escapeString($val).'\')';
//echo nl2br(sprintf("<div class='w3-white w3-border w3-padding'>[%03d] %s</div>\n",__LINE__, $sNameValPairs));
                    }
                    $sValues = \ltrim($sNameValPairs, ', ');
                    $sTableName = $sTablePrefix.'mod_accordion_settings';
                    $sql = 'INSERT INTO `'.$sTableName.'` (`section_id`, `s_name`, `s_value`) '
                         . 'VALUES '.$sValues.';';
                    if (!$database->query($sql)) {
                          $aMsg[] = sprintf("[%03d] <strong>Database error table settings %s</strong>",__LINE__,$database->get_error() );
                          $aMsg[] = sprintf("[%03d] <strong>Accordion  INSERT INTO (restore) old settings</strong> %s",__LINE__,$FAIL );
                          $iErr = true;
                    }
                }  // end for settings per section

            }
            if ($database->is_error()){
                $aMsg[] = sprintf("[%03d] <strong>Database error table settings  %s</strong> %s",__LINE__,$database->get_error(),'' );
                $aMsg[] = sprintf("[%03d] <strong>>Accordion recreate settings table</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            }
        } else {
            $aMsg[] = sprintf("[%03d] <strong>Database error table settings  %s</strong> %s",__LINE__,$database->get_error(),'' );
            $aMsg[] = sprintf("[%03d] <strong>>Accordion sqlImport</strong> %s",__LINE__,$FAIL );
            $iErr = true;
        }
        if (!$iErr) {
            $aMsg[] = sprintf("[%03d] <strong>>Accordion successful updated</strong> %s",__LINE__,$OK );
        } else {
//            $aMsg[] = '<strong>\'Folder Gallery couldn\'t updated\'</strong> '.$FAIL.'<br />';
            $aMsg[] = sprintf("[%03d] <strong>>Accordion couldn't updated</strong> %s",__LINE__,$FAIL );
        }
//        unset($getSettings);
    }
    $aRemoveList = [
                '/add.php',
                '/add_question.php',
                '/delete_question.php',
                '/modify_question.php',
                '/save_question.php',
                '/modify_settings.php',
                '/save_settings.php',
                '/move_down.php',
                '/move_up.php',
                '/css/',
                '/images/',
                '/font/',
                '/cmd/Upgrade.inc_orig.php',
                '/templates/default/css/w3.css',
                '/templates/default/css/w3-themes/',
                '/templates/default/css/w3-themes/',
                '/templates/hortal/'
              ];
   PreCheck::deleteFiles($sAddonPath,$aRemoveList);


    if (!$globalStarted && sizeof($aMsg)) {print implode("\n", $aMsg)."\n";}

} catch (\Throwable $ex) {
        /* place to insert different error/logfile messages */
        $aMsg = (\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    }
//      $sMsg = \sprintf(\implode("\n",$aMsg))."\n";
    $sMsg = ((\is_array($aMsg) && count($aMsg)) ? \sprintf(\implode("\n",$aMsg)) : "")."\n";
    if (\is_array($aMsg) && !empty($aMsg) && $iErr){
        echo nl2br(sprintf("<div class='w3-white w3-border w3-padding'>[%03d] %s</div>\n",__LINE__, $sMsg));
    }
/* */
    if (!$iErr){unset($sMsg);}
    if ($globalStarted) {
//        print Message for upgrade-script
    }

// end of file
