<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * View.inc.php
 * 
 */

//            echo "<pre>";
//            print_r($_POST);
//            echo "</pre>";
//
//            echo "<pre>";
//            print_r($_GET);
//            echo "</pre>";

use addon\accordion\Lib\Accordion;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */


if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}

    $oTrans->enableAddon('modules\\\\'.$sAddonName);
    
    $aTplDefaults = array(
            'WB_URL' => WB_URL,
            'PAGE_ID'              => PAGE_ID,
            'SECTION_ID'           => $section_id,
            'LANGUAGE'             => LANGUAGE,
            'ICON_URL'             => $sAddonTemplateUrl.'images',
            'TEMPLATE_URL'         => $sAddonTemplateUrl,
            'ADDON_URL'            => $sAddonUrl,
            'ADDON_NAME'           => $sAddonName,
        );
    
    $aTwigdata = $aTplDefaults;
    $oBEFunctions                                   = new Accordion();
//settings
$aTwigdata['setting']                           = $oBEFunctions->getAccordionSettings($section_id);
// item sort mode
$iItemOrder                                     = $oBEFunctions->getItemSortMode($section_id);
// Get comple list of entries
$aTwigdata['ITEMLIST']                          = $oBEFunctions->getAllFEItemsArray($section_id,$iItemOrder);
// read ID for output template
$iFeTemplateID                                  = $oBEFunctions->getFeTemplateID($section_id);
// read template content
$aTwigdata['TEMPLATE']                          = $oBEFunctions->getFrontendTemplate($section_id, $iFeTemplateID);
$aTwigdata['lang']                              = $oTrans->getLangArray();
//            echo $iFeTemplateID. "<pre>VIEW";
//            print_r($aTwigdata['ITEMLIST']);
//            echo "</pre>";
    
    if (is_readable($sAddonTemplatePath.'/view.twig'))
        {
            // create twig template object
            $loader = new \Twig\Loader\FilesystemLoader($sAddonTemplatePath);
            $oTwig  = new \Twig\Environment($loader, [
                'autoescape'       => false,
                'cache'            => false,
                'strict_variables' => false,
                'debug'            => false,
                'auto_reload'      => true,
            ]);
        $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
        if ($iFeTemplateID != 0 && $aTwigdata['TEMPLATE'] != ''){
                $oTpl = $oTwig->createTemplate($aTwigdata['TEMPLATE']);
                $oTpl->display($aTwigdata);
        }else{
            echo $oTwig->render('view.twig', $aTwigdata);               
        }
    }
// end of file
    

