<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 *
 * install.php
/* -------------------------------------------------------- */
use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;

if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
    $msg = [];
    $sErrorMsg = null;
    $sAddonPath = \str_replace(DIRECTORY_SEPARATOR, '/', __DIR__);
    $sAddonName = basename($sAddonPath);
    $oReg = WbAdaptor::getInstance();
    $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
    $sModulePlatform = PreCheck::getAddonVariable($sAddonName,'platform');
    if (version_compare($sWbVersion, $sModulePlatform, '<')){
        $msg[] = $sErrorMsg = sprintf('It is not possible to install from WebsiteBaker Versions before %s',$sModulePlatform);
        if ($globalStarted){
            echo $sErrorMsg;
        }else{
            throw new \Exception ($sErrorMsg);
        }
    } else {
        // create tables from sql dump file
        if (\is_readable($sAddonPath.'/install-struct.sql.php')) {
            $database->SqlImport($sAddonPath.'/install-struct.sql.php', TABLE_PREFIX, 'install');
        }
        if (\is_readable($sAddonPath.'/install-data.sql.php')) {
            $database->SqlImport($sAddonPath.'/install-data.sql.php', TABLE_PREFIX, 'install');
        }
    }

// end of file