<?php
/**
 * @category     Addons
 * @package      page module: accordion
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @author Uwe Jacobsen <webdesign@jacobi22.com>, Nibz, hgs, dbs
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.7.2
 * @lastmodified $Date: 2023/11/28
 * @since        File available since 2023/05/15
 * @description  addon accordion
 * language file
 * EN.php
  /* -------------------------------------------------------- *
 * 
 */
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}

// English Module Description
$module_description = 'Manage a Accordion page with ease!';

$ACCTEXT['ADD_FAQ']                              = 'Add FAQ';
$ACCTEXT['SETTINGS']                             = 'Settings';
$ACCTEXT['SAVE']                                 = 'Save these changes';
$ACCTEXT['CANCEL']                               = 'Cancel';
$ACCTEXT['CANCELBACK']                           = 'Cancel and Back';
$ACCTEXT['YES']                                  = 'Yes';
$ACCTEXT['NO']                                   = 'No';

$ACCTEXT['QUESTION']                             = 'Short text';
$ACCTEXT['STATUS_ON_LOAD']                       = 'Status when page is loaded';
$ACCTEXT['ANSWER']                               = 'Long text';

$ACCTEXT['METHOD']                               = 'Method';
$ACCTEXT['ICON']                                 = 'Icon';
$ACCTEXT['ICON_PLACEMENT']                       = 'Icon placement';
$ACCTEXT['LEFT']                                 = 'Left';
$ACCTEXT['RIGHT']                                = 'Right';
$ACCTEXT['HEADER']                               = 'Header (text before FAQ)';
$ACCTEXT['FOOTER']                               = 'Footer (text after FAQ)';
$ACCTEXT['ACTIVE_ICON']                          = '<- Active icon';
$ACCTEXT['CHOOSE_ICON']                          = 'Choose your icon setting';

$ACCTEXT['DEFAULT_ICON']                         = 'Default +/-';
$ACCTEXT['CHEVRONS']                             = 'Chevrons';
$ACCTEXT['SIGNS']                                = 'Signs';
$ACCTEXT['CARETS']                               = 'Carets';
$ACCTEXT['CIRCLE_ARROWS']                        = 'Circle arrows';

//sort items
$ACCTEXT['ORDERING']                             = 'ORDER';
$ACCTEXT['ASC']                                  = 'Ascending';
$ACCTEXT['DESC']                                 = 'Descending';

// neue Variablen
$ACCTEXT['TOTAL_ITEMS']                          = '%s Entries total';
$ACCTEXT['TOTAL_INACTIVE_ITEM']                  = 'thereof %s entries inactive';
$ACCTEXT['TOTAL_INACTIVE_ITEMS']                 = 'thereof %s entry inactive';
$ACCTEXT['ADD_NEW_QUESTION']                     = 'Add a new question';
$ACCTEXT['ITEM_ACTION']                          = 'Actions';
$ACCTEXT['FOUND_NO_ITEMS']	                     = 'No entries found in the database for this section';
$ACCTEXT['ITEM_IS_ACTIVE']                       = 'Item with ID = %s will be displayed';
$ACCTEXT['ITEM_IS_NOT_ACTIVE']                   = 'Item with ID = %s will not be displayed';
$ACCTEXT['ITEM_MODIFY_ID']                       = 'Edit item with ID = %s';
$ACCTEXT['ITEM_DELETE_ID']                       = 'Delete item with ID = %s';
$ACCTEXT['MOVE_ITEM_UP']                         = 'Move one position upwards';
$ACCTEXT['MOVE_ITEM_DOWN']                       = 'Move down one position';
$ACCTEXT['MODIFY_ITEM_ID']                       = 'Edit question with ID: "%s';
$ACCTEXT['STATUS_OPEN']                          = 'Answer expanded';
$ACCTEXT['STATUS_CLOSED']                        = 'Answer collapsed';
$ACCTEXT['EDITOR_ENABLED']                       = 'Switch editor on';
$ACCTEXT['EDITOR_DISABLED']                      = 'Disable editor';
$ACCTEXT['USE_WYSIWYGEDITOR']                    = 'Use WYSIWYG-Editor';
$ACCTEXT['QUEST_ACTIVE']                         = 'This question is active?';
$ACCTEXT['BACK_TO_OVERVIEW']                     = 'Back to the overview';
$ACCTEXT['OVERVIEW']                             = 'Overview';
$ACCTEXT['ITEM_REORDERED']                       = 'Position successfully changed';
$ACCTEXT['ERROR_ITEM_REORDER']                   = 'Error during the shift';
$ACCTEXT['CHOOSE_TEMPLATE']                      = 'Choose a frontend template';
$ACCTEXT['NO_TEMPLATE_FROM_DB']                  = 'Use file instead of database template';
$ACCTEXT['DISPLAY_BY_DEFAULT']                   = 'This template is currently not active in the frontend';
$ACCTEXT['DISPLAYED_BY_DEFAULT']                 = 'This is the currently active frontend template';

// sort
$ACCTEXT['POSITION']                             = 'Position';
$ACCTEXT['WHEN']                                 = 'Last change';
$ACCTEXT['QUEST']                                = 'Question';
$ACCTEXT['ASCENDING']                            = ' (ascending - A-Z)';
$ACCTEXT['DESCENDING']                           = ' (descending - Z-A)';


//  edit css
$ACCTEXT['CSS_EDITING']                          = 'Edit CSS';
$ACCTEXT['EDIT_CSS_FILE']                        = 'Edit the file: <i class="w3-text-amber">%s</i> from the module <i class="w3-text-light-blue">&quot;%s&quot;</i>';
$ACCTEXT['FILECONTENT']                          = 'File content';
$ACCTEXT['SUCCESSFULL_SAVED']                    = 'Settings saved successfully';
$ACCTEXT['CSS_SUCCESSFULL_SAVED']                = 'CSS file &quot;%s&quot; saved successfully';
$ACCTEXT['CSS_NOT_SAVED']                        = 'The file <b>&quot;%s&quot;</b> was without content and was not saved. If you want to delete all entries, select the option<b>&quot;Reset&quot;</b>';
$ACCTEXT['TEXT_CLOSE']                           = 'Back to the overview';
$ACCTEXT['CONFIRM_DEL_CSS']                      = '<div class="w3-panel w3-red"><b>Are you sure you want to remove all entries in this file?</b></div>';
$ACCTEXT['SET_CSS_DEFAULT']                      = 'Reset the CSS file';
$ACCTEXT['DELETE_ALL_CSS']                       = '<span class="w3-text-red">Attention. This function removes all entries in the CSS file and then sets the default header.</span>';

//templates
$ACCTEXT['TEMPLATE']                             = 'Template';
$ACCTEXT['TEMPLATES']                            = 'Templates';
$ACCTEXT['NO_TEMPLATE']                          = 'no template';
$ACCTEXT['EDIT_TEMPLATE']                        = 'Edit template';
$ACCTEXT['EDIT_THIS_TEMPLATE']                   = 'Edit template with ID = %s';
$ACCTEXT['TEMPLATE_NAME']                        = 'Template name';
$ACCTEXT['TEMPLATE_DESC']                        = 'Template descriptions';
$ACCTEXT['TEMPLATE_CODE']                        = 'Template code';
$ACCTEXT['PLACEHOLDER']                          = 'available placeholders';
$ACCTEXT['TEMPLATE_ACTIVE']                      = 'Template active?';
$ACCTEXT['ADD_TEMPLATE']                         = 'Create new template';
$ACCTEXT['ADD_NEW_TEMPLATE']                     = 'Create a new frontend template';
$ACCTEXT['TEMPLATE_IS_ACTIVE']                   = 'Template with ID = %s will be displayed';
$ACCTEXT['TEMPLATE_IS_NOT_ACTIVE']               = 'Template with ID = %s will not be displayed';
$ACCTEXT['TEMPLATE_MODIFY_ID']                   = 'Edit template with ID = %s';
$ACCTEXT['TEMPLATE_DELETE_ID']                   = 'Delete template with ID = %s';
$ACCTEXT['EDIT_TEMPLATE']                        = 'Edit template with ID = %s';
$ACCTEXT['ALL_TEMPLATES']                        = 'All templates';
$ACCTEXT['NO_TEMPLATES_FOUND']                   = 'No templates stored in the database';
$ACCTEXT['USE_TEMPLATEEDITOR']                   = 'Use Template-Editor?';

$ACCTEXT['HELP']                                 = 'Hilfe';
$ACCTEXT['INFO']                                 = 'Informationen';

// helptext
$ACCTEXT['MODULE_HELPTEXT'] = '<div class="frm-warning w3-padding w3-section w3-sand w3-leftbar w3-medium w3-border-green w3-hover-border-green">'
                           . '<p>Drag&Drop in the overview is only enabled for ascending sorting, setting in the module options. '
                           . 'It can be sorted by position, the question or the last changes.</p>'
                           . '</div>';
$ACCTEXT['TEMPLATE_PLACEHOLDERS'] =   '<div class="frm-warning w3-padding w3-section w3-sand w3-leftbar w3-medium w3-border-green w3-hover-border-green"><ul>'
                                    . '<h3>Available variables and arrays in templates</h3>'
                                    . 'The markup language for these templates is = <a href="https://twig.symfony.com/doc/3.x/" target="_blank"><b>TWIG</b></a>. Possible would be the usual functions and filters in TWIG, e.g. to display the date from a timestamp.<br>'
                                    . 'The array <b><i>setting</i></b> contains all values from the module settings, the array <b><i>ITEMLIST</i></b> contains all defined contents, i.e. questions and answers.<br>'
                                    . 'Within the loop, the contents of individual questions are addressed with <b><i>item</i></b>.<br><br><h4><u>Available variables</u></h4>'
                                    . '<dl>'
                                          . '<dt><b>setting.header</b></dt>'
                                          . '<dd>the HEADER code, defined in the module settings</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>setting.icon_placement</b></dt>'
                                          . '<dd>Icon left or right (see Module Settings -> Icon Placement)</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>setting.icon</b></dt>'
                                          . '<dd>which icon is used (see Module Settings -> Icon)</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>SECTION_ID</b></dt>'
                                          . '<dd>Section-ID</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>for item in ITEMLIST</b></dt>'
                                          . '<dd>all entries for this group in this array</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>item.status_on_pageload</b></dt>'
                                          . '<dd>Status of the response in the frontend (expanded or collapsed)</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>item.question</b></dt>'
                                          . '<dd>the question</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>item.answer</b></dt>'
                                          . '<dd>the answer</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>item.modified_when</b></dt>'
                                          . '<dd>Timestamp of the last change (must be formatted)</dd>'
                                    . '</dl>'        
                                    . '<dl>'
                                          . '<dt><b>endfor</b></dt>'
                                          . '<dd>End of the for-loop</dd>'
                                    . '</dl>'
                                    . '<dl>'
                                          . '<dt><b>setting.footer</b></dt>'
                                          . '<dd>the FOOTER code, defined in the module settings</dd>'
                                    . '</dl>'
                                .'</div>';

$ACCTEXT['INACTIVE_SECTION']    = '<div class="w3-container w3-panel w3-pale-red w3-padding-12">'
                                . '<b>You are editing another section</b>'
                                . '</div>';
// end of file